(function (){	
	//Generic Map Function to support IE
	(function(fn){
    	if (!fn.map) fn.map=function(f){var r=[];for(var i=0;i<this.length;i++)r.push(f(this[i]));return r}
    	if (!fn.filter) fn.filter=function(f){var r=[];for(var i=0;i<this.length;i++)if(f(this[i]))r.push(this[i]);return r}
	})(Array.prototype);


	function _encodeUrl(baseUrl, params) {
		Object.keys = function(params) {
		var keys = [];    
		for (var i in params) {
			if (params.hasOwnProperty(i)) {
	        	keys.push(i);
	      	}
	    }
		return keys;
		};
	    var _encodedURL =  Object.keys(params).map(function(key) {
    							return [key, params[key]].map(encodeURIComponent).join("=");
							}).join("&");
		return baseUrl + _encodedURL;
    }
	
	function cacheBuster(url){
		var _buster = Math.round(Math.random() * 100000000000000);
		return url + "&b=" + _buster
	}

	function playListShuffle(playlist){
		var currentIndex = playlist.length, temporaryValue, randomIndex ;

		// While there remain elements to shuffle...
		while (0 !== currentIndex) {
			// Pick a remaining element...
			randomIndex = Math.floor(Math.random() * currentIndex);
			currentIndex -= 1;

			// And swap it with the current element.
			temporaryValue = playlist[currentIndex];
			playlist[currentIndex] = playlist[randomIndex];
			playlist[randomIndex] = temporaryValue;
		}
		return playlist;
	}

	function hideSplash(){
		document.getElementById(_playerId + "_placeholder").style.cssText = "display:none;";
	}
	function showSplash(){
		document.getElementById(_playerId + "_placeholder").style.cssText = "display:block;position:absolute;z-index:1000";
	}
	
	
	var _GA_ACCOUNTID_ = "UA-50293334-1";
	var _playerId = 'lyoau-adblock-player';
	if (typeof window._ox_width === 'undefined') var _playerWidth = 400;
	else var _playerWidth = _ox_width;
	if (typeof window._ox_height === 'undefined') var _playerHeight = 300;
	else var _playerHeight = _ox_height;

	
	if (typeof window._ox_fallback === 'undefined') var _ox_fallback = 5000;
	else var _ox_fallback = _ox_fallback*1000;

	var _clickThruTrackUrl;
	if(typeof window._ox_curl === 'undefined' ){
		_clickThruTrackUrl = "";
	}else{
		_clickThruTrackUrl = window._ox_curl;
	}
	if (typeof window._ox_sound === 'undefined') var _ox_sound = true;
	else var _ox_sound = window._ox_sound;
	if (_ox_sound) 
	{
		var lr_mute = 0
		var lr_volume = '.2';
		var jw_mute = false;
	}
	else
	{
		var lr_mute = 1
		var lr_volume = '0';
		var jw_mute = true;
	}
	
	if (typeof window._ox_vertical === 'undefined') var _ox_vertical = 'tv_ent_slider';
	else var _ox_vertical = window._ox_vertical;
	
	if (typeof window._ox_tags === 'undefined') var _ox_tags = '';	
	else var _ox_tags = window._ox_tags;
	
	var _contentFeedURL = "http://contentapi.ws/videos?channel=movies&limit=10&format=long";
	var _vastBaseUrl = "http://ad4.liverail.com/?";
	var _vastUrlParams =  {"LR_PUBLISHER_ID": 9667, 
							"LR_PARTNERS": 750127, 
							"LR_SCHEMA": "vast2-vpaid",
							"LR_VERTICALS": _ox_vertical, 
							"LR_TITLE": "__item-title__",
							"LR_VIDEO_ID": Math.random() * 1000000,
							"LR_AUTOPLAY": 1, 
							"LR_CONTENT": 1, 
							"LR_TAGS": _ox_tags,
							"LR_TIMEOUT_DELIVERY":2,
							"LR_TIMEOUT_ADSOURCE":2,
							"LR_TIMEOUT_VPAID_INIT":3,
							"LR_TIMEOUT_VPAID_START":3,
							"hideCompanion": 1, 
							"height":_playerHeight,
							"width":_playerWidth,
							"volume": 20,//lr_volume,
							"LR_LAYOUT_BACKGROUND" : 1,
							"LR_MUTED": lr_mute
	};
	
	var _vastOverlayUrlParams =  {"LR_PUBLISHER_ID": 9667, 
			"LR_PARTNERS": 750127, 
			"LR_SCHEMA": "vast2-vpaid",
			"height":_playerHeight, 
			"width": _playerWidth ,
			"LR_VERTICALS": _ox_vertical, 
			"LR_TITLE": "__item-title__",
			"LR_VIDEO_ID": Math.random() * 1000000,
			"LR_TAGS": _ox_tags,
			"LR_CONTENT":1,
			"LR_ADUNIT":"ov",
			"LR_VIDEO_POSITION":20,
			"LR_LAYOUT_OVERLAY_PILL":0

		};

	
	var _use_fallback = false;
	
	var _logoLink = "http://lycostv.com";
	var _videoClickLandingBaseUrl = "http://www.lycostv.com/"
	var _video_host = "http://video1.contentapi.ws";
	var _image_host = "http://img1.contentapi.ws";	
		
	var _logoFile = "";//http://obp.lygo.tv/OLTV-Header.png";
	var _brandingVideo = _ox_assets_path+"LyBlankSplash.mp4";
	var _play_preroll = false;
	var _playlist_manual = false;
	var _ad_timeout = null;
	var _jw_ready = false;
	var _tracked_first = false;
	
	var _playControlElem = null;
	var _volumeContolElem = null;
	
	var _aboutText = "LycosTV";
	var _aboutLink  = "http://www.lycostv.com";

	var _d = new Date();
	var _obPlayerOptions = {
		primary: 'flash',
		autostart: true,
		mute: jw_mute,
		volume: 40,
		abouttext: _aboutText,
		aboutlink: _aboutLink,
		width: _playerWidth,
		height: _playerHeight,
		repeat:true,
//		controls: false,
		stretching: 'uniform',
		aspectratio: '16:9',
		advertising: {
			client: 'vast',
			schedule: {
    			overlay: {
    				offset:20,
    				tag: _encodeUrl(_vastBaseUrl, _vastOverlayUrlParams),
    				type: "nonlinear"
    			}
    		}
		},
		logo: {
		//	hide: true,
			file: _logoFile,
			link: _logoLink,
			position: "top-left",
			margin: 1
		},
		ga: {
        	idstring: "title",
        	trackingobject: "pageTracker"
    	},
    	events: {
    		onReady: function() {
    		
    			document.getElementById('lyoau-adblock-player_wrapper').style.position = 'absolute';
    			fireBeacon('videoAdAttJWP','');
    			if (!_jw_ready)
    			{
    				_jw_ready = true;
    				lycobp.buildPlayerOverlay(_playerId);
    			}
    		},
    		onPlaylistItem: function(e){		
    			if (e.index / 2 === Math.floor(e.index/2) && !_playlist_manual)
    			{
    				_play_preroll = true;
    	  		}      
    			else
    			{
    				var _oldLink = document.getElementById(_playerId + "_link");
    				if (_oldLink !== null) _oldLink.parentNode.removeChild(_oldLink);//document.getElementById(_playerId + "_link")
        			var _displayClickLink = document.createElement('a');
        			var _landingPage = _videoClickLandingBaseUrl + "index.php?fid="+this.getPlaylistItem(this.getPlaylistIndex())._id+"&title="+this.getPlaylistItem(this.getPlaylistIndex()).title;
        			_displayClickLink.setAttribute('id', _playerId + "_link");
        			_displayClickLink.setAttribute('style','height:'+_playerHeight+'px;width:'+_playerWidth+'px;opacity:0;filter: alpha(opacity=0);z-index:1005;display:block;position:absolute;top:5px;left:5px;background-color: #000');
        			_displayClickLink.setAttribute('href', _landingPage);
        			_displayClickLink.setAttribute('target', '_blank');
        			document.getElementById('lyoau-adblock-holder').appendChild(_displayClickLink);
    			}
    			_playlist_manual = false;
    			
    		},
    		onPlay:function()
    		{
    			if (jw_mute) { jwplayer(_playerId).setMute(true); }
    			else { jwplayer(_playerId).setMute(false); }
    			_ad_timeout = null;
    			hideSplash();
    		},
    		onComplete:function()
    		{
    			var _oldLink = document.getElementById(_playerId + "_link");
				if (_oldLink !== null) _oldLink.parentNode.removeChild(_oldLink);
    			showSplash();
    		},
    		onBeforePlay: function()
    		{
    			if (_play_preroll)
    			{
    				_play_preroll = false;
    				var adTag = _encodeUrl(_vastBaseUrl, _vastUrlParams);
    				_preroll_active = true;
    				this.playAd(adTag);
    			}
    		},
    		onAdComplete: function(event) {
    			if (_preroll_active)
    			{ 
    				_preroll_active = false; 	
    				lycobp.adComplete();
    			}
    
    		},
    		onDisplayClick: function(){
    			// fallback method for clicking on video if an overlay is up
    			var _displayClickLink = document.createElement('a');
    			var _landingPage = _videoClickLandingBaseUrl + "index.php?fid=" +this.getPlaylistItem(this.getPlaylistIndex())._id+"&title="+this.getPlaylistItem(this.getPlaylistIndex()).title;
    			_displayClickLink.setAttribute('href', _landingPage);
    			_displayClickLink.setAttribute('target', '_blank');
    			document.body.appendChild(_displayClickLink);
    			_displayClickLink.click();
    			
    	  		//When controls are on, JWplayer by default pauses the video. So lets toggle the play on this event
    	  		//On Display click, target page is opened in new tab but player pauses. Check the state and continue to play
    	  		var _playerState = this.getState();
    	  		if(_playerState == "PAUSED"){
    	  			this.play();	
    	  		}    	  		
    		},
    		onAdClick : function(){
    			if (_preroll_active)
    			{ 
	    	  		var _playerState = this.getState();
	    	  		if(_playerState == "PAUSED"){
	    	  			this.play();	
	    	  		}
    			}
    			fireBeacon('videoAdClickJWP','');
    		},
    		onAdError: function(){
    			if (_preroll_active)
    			{ 
    				_preroll_active = false; 			
    				lycobp.adError();
    				
    			}
    		},
    		onAdImpression: function(){
    			if (_preroll_active)
    			{ 
    				_preroll_active = false; 
	    			_ad_timeout = null;
	    			if (lr_mute == 1) { setTimeout(function() { jwplayer(_playerId).setVolume(25);jwplayer(_playerId).setMute(true);}, 500); }
	    			hideSplash();
					
	    			var passthrough_value = '';
					if (!_tracked_first)
					{
						_tracked_first = true;
						var s = new Date(); var diff = s - _d;
						passthrough_value = Math.ceil(diff/1000);
					}
					fireBeacon('videoAdStartJWP',passthrough_value);
					_first_preroll = false;	
    			}
    			else
    			{
    				var _clickLink = document.getElementById(_playerId + "_link");
    				_clickLink.style.height = (_playerHeight-55)+ 'px';
    			}
    		}
    		
    		
    	}
	};
	
	
		// Base function.
	var LycosObp = function() {
	};

	LycosObp.VERSION = '1';

	//Helper Function to set Attributes
	function setAttributes(el, attrs) {
 		for(var key in attrs) {
    		el.setAttribute(key, attrs[key]);
  		}
	}

	//Insance Methods
	LycosObp.prototype = {
		//Build the playlist from feed API with branding videos mixed in
		buildPlaylist: function(brandingVideo, lycobp){
			var videos, shuffledVideos;
			var playList=[];
			var branding = {
                    "image":"",
                    "sources":
                    [{
                      file: brandingVideo
                    }],
                    "title": "LycosTV"
          		};
			
			LycosObp.xdrGetJSON(_contentFeedURL, function(data) {
					   if (typeof window.JSON === 'undefined') {  // <= IE8 Workaround
					        var feed = eval('(' + data + ')');
					    }
					    else {
					    	var feed = JSON.parse(data);
					    }
						videos = feed.articles;
			            shuffledVideos = playListShuffle(videos);
			            for(var i=0; i< shuffledVideos.length; i++)
			            { 
			            	
			            	shuffledVideos[i]['sources'] = [{'file':_video_host + "/" + shuffledVideos[i]['video']}];
			            	shuffledVideos[i]['image'] = _image_host + "/" + shuffledVideos[i]['thumb_image'];
			            	playList[(i*2)+1] = shuffledVideos[i]; 
			            	playList[(i*2)] = branding
			            };
			            
			        	lycobp.setup(_playerId, _obPlayerOptions, playList);
			        	lycobp.buildTrackerWrapper(_playerId);

					},
					function(status) {

					});
		},	

		//Setup JWPlayer with config options
		setup: function(playerId, playerOptions, videoPlayList){			
			if(jwplayer){
				var playerConfig = playerOptions;
				playerConfig.playlist = videoPlayList;
				jwplayer.key = jwplayerKey;
				jwplayer("lyoau-adblock-player").setup(playerConfig);
			}
		},

		//Overlay to contain volume and play controls
		buildPlayerOverlay: function(_playerId){
	        var wrapperId = _playerId + "_wrapper"
	        var _parent = document.getElementById(wrapperId);
	        
	 
	        var _obpOverlay = document.createElement("div");
	        var _overlayId = _playerId + "_overlay";
	        _obpOverlay.setAttribute("id", _overlayId);
	        var _overlayCssString = "position:absolute;bottom:5px; left:"+(parseInt(_ox_width)-50)+"px; width:50px; display:block; -moz-border-radius:5px; -wbebkit-border-radius:5px; border-radius:5px; height:28px;z-index:1010"; 
	        _parent.appendChild(_obpOverlay);
	        document.getElementById(_overlayId).style.cssText = _overlayCssString;
	        
	        var _volumeControl = document.createElement('div');
	        var _volumeControlId = _playerId + "_volControl";
	        _volumeControl.setAttribute('id', _volumeControlId);
	 
	        var _volumeControlCss = "no-repeat left top; width:16px; height:16px; margin:6px 0 0 0px; cursor:pointer; right:6px; position:absolute; opacity:0.6;z-index:1010";
	        if (!_ox_sound) _volumeControlCss = "background:url("+_ox_assets_path+"mute-white-icon.png) "+_volumeControlCss;
	        else _volumeControlCss = "background:url('"+_ox_assets_path+"volume-white-icon-2.png') "+_volumeControlCss; 
	        	
	        _obpOverlay.appendChild(_volumeControl);
	        _volumeContolElem = document.getElementById(_volumeControlId);
	        
	        //Volume Handler on the overlay -Toggles Volume
	        if (_volumeContolElem.addEventListener)
	       	{
	        	_volumeContolElem.addEventListener("click", function() {lycobp.volumeControlEvent();}, false);
	       	}
	        else
	        {
	        	_volumeContolElem.attachEvent("onclick", function() {lycobp.volumeControlEvent();});
	        }
	        
			document.getElementById(_volumeControlId).style.cssText = _volumeControlCss;


			var _playControl = document.createElement('div');
			var _playControlId = _playerId + "_playControl";
			_playControl.setAttribute('id', _playControlId);
			var _playControlCss = "background:url("+_ox_assets_path+"pause-white-icon.png) no-repeat left top;width:16px; height:16px; margin:6px 0 0 0px; cursor:pointer; right:29px; position:absolute; opacity:0.6;";
			_obpOverlay.appendChild(_playControl);
	        _playControlElem = document.getElementById(_playControlId);
	        
			  //Toggle Play and Pause on the player
	        if (_playControlElem.addEventListener)
	       	{
	        	_playControlElem.addEventListener("click", function() {lycobp.playControlEvent();}, false);
	       	}
	        else
	        {
	        	_playControlElem.attachEvent("onclick", function() {lycobp.playControlEvent();});
	        }
			
			document.getElementById(_playControlId).style.cssText = _playControlCss;

	    },

	    volumeControlEvent : function()
	    {
	    	var _player = jwplayer(_playerId);
			var _volumeState = _player.getMute();
			if(_volumeState){
				lr_mute = 0;
			    _player.setMute(false);	jw_mute = false;
			    _volumeContolElem.style.background = "url('"+_ox_assets_path+"volume-white-icon-2.png')";
			}
			else{
				lr_mute = 1; jw_mute = true;
			    _player.setMute(true);	
			    _volumeContolElem.style.background = "url('"+_ox_assets_path+"mute-white-icon.png')";	
			}
       	},
       	playControlEvent : function(){	   
        	var _player = jwplayer(_playerId);
			var _playerState = _player.getState();
			if(_playerState == "PAUSED"){
				_player.play();
				_playControlElem.style.background = "url('"+_ox_assets_path+"pause-white-icon.png')";
			}else if(_playerState == "PLAYING"){
				_player.pause();
				_playControlElem.style.background = "url('"+_ox_assets_path+"play-white-icon.png')";
			}    
        }, 
       	
        adError: function()
        {
        	jwplayer(_playerId).pause();
			loadDisplayFallback();
			setTimeout(function() {
				unloadDisplayFallback();
				_use_fallback = false;
				lycobp.adComplete();
			}, 30000);
			
			var passthrough_value = '';
			if (!_tracked_first)
			{
				_tracked_first = true;
				var s = new Date(); var diff = s - _d;
				passthrough_value = Math.ceil(diff/1000);
			}
			fireBeacon('videoAdErrorJWP',passthrough_value);
        },
        
        adComplete: function()
        {
        	var position = jwplayer(_playerId).getPlaylistIndex()
        	_playlist_manual = true;
			jwplayer(_playerId).playlistItem(position + 1);
        },
        
	    //Helper function Return the tracker Wrapper when playerID provided
	    getTrackerWrapper: function(playerId){
	    	return playerId + "_trackerWrapper";
	    },

	    //Build a tracker Wrapper and add all fired pixels to this wrapper
	    buildTrackerWrapper: function(playerId){
	    	var _trackerWrapper = document.createElement('div');
	    	_trackerWrapper.id = playerId + "_trackerWrapper";
	    	_trackerWrapper.style.display = "none";
	    	document.body.appendChild(_trackerWrapper);
	    }
	    
	};	


	LycosObp.xdrGetJSON = function(url, successHandler, errorHandler) {
	    var browser = navigator.userAgent;
	    var IEversion = 99; 
	     
	    if (browser.indexOf("MSIE") > 1) { 
	        IEversion = parseInt(browser.substr(browser.indexOf("MSIE")+5, 5));
	    }
	    if (IEversion < 10) {            
	        xdr = new XDomainRequest(); 
	        
	        if(xdr){
	        	xdr.onload = function () {
	        		successHandler(xdr.responseText);
	        	};
				xdr.open("get", url); 
		        xdr.send(); 
		    }
	    } else{
	        var xhr = new XMLHttpRequest();
	        xhr.open('get', url, false);
	        xhr.onload = function() {
	            var status = xhr.status;
	            if (status == 200) {
	                successHandler && successHandler(xhr.responseText);
	            } else {
	                errorHandler && errorHandler(status);
	            }
	        };
	        xhr.send();
	    }
	};
	
	var lycobp = new LycosObp();	
	lycobp.buildPlaylist(_brandingVideo, lycobp);

	
	function fireBeacon(event,value)
	{
		var bv2 = document.createElement('script'); 
		bv2.type = 'text/javascript'; 
		bv2.async = true;
		bv2.src = 'http://beacon.lycos.com/e.php?h=obp.lygo.tv&t='+_ox_vertical+'&a='+value+'&e='+event+'&s=OAU&b='+Math.floor(Math.random()*1000000);
		var s = document.getElementsByTagName('script')[0]; 
		s.parentNode.insertBefore(bv2, s);
	};


	

})();